package ssd;

import org.xml.sax.*;

public class DOMErrorHandler implements ErrorHandler {

	
	/********************[ Error handling ]**********************/
	
	public void warning(SAXParseException e) throws SAXException {
		printError("WARNING",e);
	}
	
	public void error(SAXParseException e) throws SAXException {
		printError("ERROR",e);
	}
	
	public void fatalError(SAXParseException e) throws SAXException {
		printError("FATAL",e);
	}
	
	private void printError(String severity, SAXParseException e) {
		System.out.printf(" --> %s at %3d,%3d: %s\n"
				, severity
				, e.getLineNumber()
				, e.getColumnNumber()
				, e.getMessage());
	}
}
