package ssd;

import java.io.FileInputStream;

import javax.xml.transform.Result;
import javax.xml.transform.Source;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.sax.SAXSource;
import javax.xml.transform.stream.StreamResult;

import org.w3c.dom.Document;
import org.xml.sax.InputSource;
import org.xml.sax.XMLFilter;
import org.xml.sax.XMLReader;
import org.xml.sax.helpers.XMLReaderFactory;

public class SAXDemo {

	public static void main(String[] args) throws Exception {
		// read file
		FileInputStream fis = new FileInputStream(args[0]);
		InputSource is = new InputSource(fis);
		
		// create XMLReader and register the handlers
		XMLReader xr = XMLReaderFactory.createXMLReader();
		
		XMLFilter xf = new SSDFilter();
		xf.setParent(xr);
		xr = xf; // change only the reference of xr, not the Object!
		
//		SSDHandler handler = new SSDHandler();
//		xr.setContentHandler(handler);
//		xr.setErrorHandler(handler);
		
		// modify default features
		xr.setFeature("http://xml.org/sax/features/validation", false); // should validation errors be reported?
		xr.setFeature("http://xml.org/sax/features/namespaces", true); // include namespaces and localNames in events
		xr.setFeature("http://xml.org/sax/features/namespace-prefixes", false); // report xmlns:* attributes
		
		// parse the file and report events to the handler
		xr.parse(is);
		fis.close();
		
		fis = new FileInputStream(args[0]); // reopen the file
		is = new InputSource(fis); // generate a new InputSource
		outputTransformer(xr, is, "filenameSAXTransformer.xml"); //reuses the xr XMLReader
		fis.close();
	}
	
	public static void outputTransformer(XMLReader reader, InputSource input, String filename) throws Exception {
		TransformerFactory tf = TransformerFactory.newInstance();
		Transformer t = tf.newTransformer();
		
		Source ds = new SAXSource(reader, input);
		Result sink = new StreamResult(filename);
		
		t.transform(ds, sink);
	}

}
